#ifndef SNEeSe_cpu_h
#define SNEeSe_cpu_h

#include "misc.h"

EXTERN void Reset_CPU(void);
EXTERN void Do_CPU(void);

/* Interrupt vectors */
EXTERN unsigned NMI_Nvector,NMI_Evector;
EXTERN unsigned IRQ_Nvector,IRQ_Evector;
EXTERN unsigned COP_Nvector,COP_Evector;
EXTERN unsigned BRK_Nvector;

/* CPU registers and etc. */
EXTERN unsigned _65816_X;
EXTERN unsigned _65816_Y;  // X and Y indices
EXTERN unsigned _65816_A;  // Accumulator
EXTERN unsigned _65816_P;  // Flags register
EXTERN unsigned _65816_S;  // Stack pointer
EXTERN unsigned _65816_D;  // Direct Address
EXTERN unsigned _65816_PC; // Program counter
EXTERN unsigned long _65816_DB_Shifted;
EXTERN unsigned long _65816_PB_Shifted;
#define _65816_DB ((unsigned char) (_65816_DB_Shifted >> 16))
#define _65816_PB ((unsigned char) (_65816_PB_Shifted >> 16))

EXTERN unsigned LastRenderLine;
EXTERN unsigned LastVBLLine;
#endif /* SNEeSe_cpu_h */
