; 65c816 opcodes 0x50-0x5F:
;    50: BVC r       2,2
;    51: EOR (d),y   2,5
;    52: EOR (d)     2,5
;    53: EOR (d,s),y 2,7
;    54: MVN xya     3,7
;    55: EOR d,x     2,4
;    56: LSR d,x     2,6
;    57: EOR [d],y   2,6
;    58: CLI i       1,2
;    59: EOR a,y     3,4
;    5A: PHY s       1,2
;    5B: TCD i       1,2
;    5C: JML al      4,4
;    5D: EOR a,x     3,4
;    5E: LSR a,x     3,7
;    5F: EOR al,x    4,5

; 50
BFC BVC,SNES_FLAG_V

; 51
EM_EOR OdO_y,Direct_Indirect_Indexed
E0_EOR OdO_y,Direct_Indirect_Indexed

; 52
EM_EOR OdO,Direct_Indirect
E0_EOR OdO,Direct_Indirect

; 53
EM_EOR Od_sO_y,Stack_Relative_Indirect_Indexed
E0_EOR Od_sO_y,Stack_Relative_Indirect_Indexed

; 54

ALIGNC
E0_MVN:
 push ebx           ; Cycles per instruction iteration
.again:
 mov al,[1+R_NativePC]  ; Dest bank
 mov bl,[2+R_NativePC]  ; Src bank
 mov B_DB,al
 mov ax,B_X         ; Src address
 shl ebx,16
 add ebx,eax
 inc eax
 mov B_X,ax
 GET_BYTE
 mov ebx,B_DB_Shifted
 mov bx,B_Y        ; Dest address
 SET_BYTE
 mov eax,B_A
 inc ebx
 sub eax,byte 1
 mov B_Y,bx
 jc  .done
 cmp B_EventTrip,R_Cycles
 jbe .event
 mov B_A,ax
 add R_Cycles,[esp]
 xor eax,eax
 xor ebx,ebx
 jmp .again
ALIGNC
.done:
 add R_NativePC,byte 3
.event:
 mov B_A,ax
 pop edi
 jmp near CPU_RETURN
	
ALIGNC
EX_MVN:
 push ebx           ; Cycles per instruction iteration
.again:
 mov al,[1+R_NativePC]  ; Dest bank
 mov bl,[2+R_NativePC]  ; Src bank
 mov B_DB,al
 mov al,B_X         ; Src address
 shl ebx,16
 add ebx,eax
 inc eax
 mov B_X,al
 GET_BYTE
 mov ebx,B_DB_Shifted
 mov bl,B_Y         ; Dest address
 SET_BYTE
 mov eax,B_A
 inc ebx
 sub eax,byte 1
 mov B_Y,bl
 jc  .done
 cmp B_EventTrip,R_Cycles
 jbe .event
 mov B_A,ax
 add R_Cycles,[esp]
 xor eax,eax
 xor ebx,ebx
 jmp .again
ALIGNC
.done:
 add R_NativePC,byte 3
.event:
 mov B_A,ax
 pop edi
 jmp near CPU_RETURN

; 55
EM_EOR d_x,Direct_Index_X
E0_EOR d_x,Direct_Index_X

; 56
EM_LSR d_x,Direct_Index_X
E0_LSR d_x,Direct_Index_X

; 57
EM_EOR IdI_y,Direct_Indirect_Indexed_Long
E0_EOR IdI_y,Direct_Indirect_Indexed_Long

; 58

ALIGNC
E0_CLI:
 inc R_NativePC
 CLR_FLAG SNES_FLAG_I
 mov al,[IRQ_pin]
 test al,al
 jz near CPU_RETURN
 SAVE_PC ebx
 add R_Cycles,byte 60   ; IRQ processing: 2 IO + 6 bank0
 call E0_IRQ
 LOAD_PC
 jmp near CPU_RETURN

ALIGNC
E1_CLI:
 inc R_NativePC
 CLR_FLAG SNES_FLAG_I
 mov al,[IRQ_pin]
 test al,al
 jz near CPU_RETURN
 SAVE_PC ebx
 add R_Cycles,byte 52   ; IRQ processing: 2 IO + 5 bank0
 call E1_IRQ
 LOAD_PC
 jmp near CPU_RETURN

; 59
EM_EOR a_y,Absolute_Index_Y
E0_EOR a_y,Absolute_Index_Y

; 5A

ALIGNC
E0_PHY:
 inc R_NativePC
 mov eax,B_Y
 E0_PUSH_W
 jmp near CPU_RETURN

ALIGNC
EX_PHY:
 inc R_NativePC
 mov eax,B_Y
 E0_PUSH_B
 jmp near CPU_RETURN

ALIGNC
E1_PHY:
 inc R_NativePC
 mov eax,B_Y
 E1_PUSH_B
 jmp near CPU_RETURN

; 5B

ALIGNC
ALL_TCD:
 inc R_NativePC
 mov eax,B_A
 mov B_D,eax
;test ax,ax
 shl eax,16
 STORE_FLAGS SNES_FLAG_NZ
 jmp near CPU_RETURN

; 5C

ALIGNC
ALL_JML_al:
 mov al,[1+R_NativePC]
 xor ebx,ebx
 mov ah,[2+R_NativePC]
 mov bl,[3+R_NativePC]
 mov B_PB,bl
 mov R_NativePC,eax
 test [MEMSEL],bl       ; Check bus speed against PB
 mov al,5
 jnz .fastrom
 mov al,4
.fastrom:
 mov [CycleTable],al    ; Update bus speed
 mov edi,R_NativePC
 shl ebx,16
 or edi,ebx

 shr edi,13
 mov edi,[_Read_Bank8Offset+edi*4]
 test edi,edi
 jnz .read_direct

 xor ebx,ebx
 mov edi,_Blank     ;we should really trap this...
.read_direct:
 add edi,ebx

 add R_NativePC,edi
 mov B_PBOffset,edi

 jmp near CPU_RETURN

; 5D
EM_EOR a_x,Absolute_Index_X
E0_EOR a_x,Absolute_Index_X

; 5E
EM_LSR a_x,Absolute_Index_X
E0_LSR a_x,Absolute_Index_X

; 5F
EM_EOR al_x,Absolute_Long_Index_X
E0_EOR al_x,Absolute_Long_Index_X
