; 65c816 opcodes 0x60-0x6F:
;    60: RTS s       1,6
;    61: ADC (d,x)   2,6
;    62: PER s       3,6
;    63: ADC d,s     2,4
;    64: STZ d       2,3
;    65: ADC d       2,3
;    66: ROR d       2,5
;    67: ADC [d]     2,6
;    68: PLA s       1,4
;    69: ADC #       2,2
;    6A: ROR A       1,2
;    6B: RTL s       1,6
;    6C: JMP (a)     3,5
;    6D: ADC a       3,4
;    6E: ROR a       3,6
;    6F: ADC al      4,5

; 60

ALIGNC
E0_RTS:
 E0_PULL_W
 inc ax     ; This is a MAD processor!

 mov ebx,B_PB_Shifted
 mov R_NativePC,eax
 or eax,ebx

 shr eax,13
 mov eax,[_Read_Bank8Offset+eax*4]
 test eax,eax
 jnz .read_direct

 xor ebx,ebx
 mov eax,_Blank     ;we should really trap this...
.read_direct:
 add eax,ebx

 add R_NativePC,eax
 mov B_PBOffset,eax

 jmp near CPU_RETURN
ALIGNC
E1_RTS:
 E1_PULL_W
 inc ax     ; This is a MAD processor!

 mov ebx,B_PB_Shifted
 mov R_NativePC,eax
 or eax,ebx

 shr eax,13
 mov eax,[_Read_Bank8Offset+eax*4]
 test eax,eax
 jnz .read_direct

 xor ebx,ebx
 mov eax,_Blank     ;we should really trap this...
.read_direct:
 add eax,ebx

 add R_NativePC,eax
 mov B_PBOffset,eax

 jmp near CPU_RETURN

; 61
EM_ADC Od_xO,Direct_Indexed_Indirect
E0_ADC Od_xO,Direct_Indexed_Indirect

; 62

ALIGNC
E0_PER:
 mov al,[1+R_NativePC]
 mov ah,[2+R_NativePC]
 add R_NativePC,byte 3
 GET_PC ebx
 add eax,ebx
 E0_PUSH_W
 jmp near CPU_RETURN

ALIGNC
E1_PER:
 mov al,[1+R_NativePC]
 mov ah,[2+R_NativePC]
 add R_NativePC,byte 3
 GET_PC ebx
 add eax,ebx
 E1_PUSH_W
 jmp near CPU_RETURN

; 63
EM_ADC d_s,Stack_Relative
E0_ADC d_s,Stack_Relative

; 64
EM_STZ d,Direct
E0_STZ d,Direct

; 65
EM_ADC d,Direct
E0_ADC d,Direct

; 66
EM_ROR d,Direct
E0_ROR d,Direct

; 67
EM_ADC IdI,Direct_Indirect_Long
E0_ADC IdI,Direct_Indirect_Long

; 68

ALIGNC
E0_PLA:
 inc R_NativePC
 E0_PULL_W
 mov B_A,eax
;test ax,ax
 shl eax,16
 STORE_FLAGS SNES_FLAG_NZ
 jmp near CPU_RETURN
ALIGNC
EM_PLA:
 inc R_NativePC
 E0_PULL_B
 mov B_A,al
 test al,al
 STORE_FLAGS SNES_FLAG_NZ
 jmp near CPU_RETURN
ALIGNC
E1_PLA:
 inc R_NativePC
 E1_PULL_B
 mov B_A,al
 test al,al
 STORE_FLAGS SNES_FLAG_NZ
 jmp near CPU_RETURN

; 69
EM_ADC i,Immediate
E0_ADC i,Immediate

; 6A    ; Fixed 0.25: RRA8 didn't set NZ flags correctly

ALIGNC
EM_RRA:
 shr R_P_B,byte 1   ; MAKE_CARRY
 mov al,B_A
 inc R_NativePC
 rcr al,byte 1
 adc R_P_B,R_P_B    ; STORE_FLAGS SNES_FLAG_C
 test al,al
 STORE_FLAGS SNES_FLAG_NZ
 mov B_A,al
 jmp near CPU_RETURN

ALIGNC
E0_RRA:
 shr R_P_B,byte 1   ; MAKE_CARRY
 mov edi,B_A
 inc R_NativePC
 rcr di,byte 1
 adc R_P_B,R_P_B    ; STORE_FLAGS SNES_FLAG_C
 test di,di
 STORE_FLAGS SNES_FLAG_NZ
 mov B_A,edi
 jmp near CPU_RETURN

; 6B

ALIGNC
E0_RTL:
 E0_PULL_W
 inc ax     ; This is a MAD processor!
 mov R_NativePC,eax
 E0_PULL_B
 mov B_PB,al
 test [MEMSEL],al   ; Check bus speed against PB
 mov bl,5
 jnz .fastrom
 mov bl,4
.fastrom:
 mov ah,0
 mov [CycleTable],bl    ; Update bus speed
 mov edi,R_NativePC
 shl eax,16
 or edi,eax

 shr edi,13
 mov edi,[_Read_Bank8Offset+edi*4]
 test edi,edi
 jnz .read_direct

 xor eax,eax
 mov edi,_Blank     ;we should really trap this...
.read_direct:
 add edi,eax

 add R_NativePC,edi
 mov B_PBOffset,edi

 jmp near CPU_RETURN
ALIGNC
E1_RTL:
 E1_PULL_W
 inc ax     ; This is a MAD processor!
 mov R_NativePC,eax
 E1_PULL_B
 mov B_PB,al
 test [MEMSEL],al   ; Check bus speed against PB
 mov bl,5
 jnz .fastrom
 mov bl,4
.fastrom:
 mov ah,0
 mov [CycleTable],bl    ; Update bus speed
 mov edi,R_NativePC
 shl eax,16
 or edi,eax

 shr edi,13
 mov edi,[_Read_Bank8Offset+edi*4]
 test edi,edi
 jnz .read_direct

 xor eax,eax
 mov edi,_Blank     ;we should really trap this...
.read_direct:
 add edi,eax

 add R_NativePC,edi
 mov B_PBOffset,edi

 jmp near CPU_RETURN

; 6C

; JMP Absolute Indirect
; Returns PCH in %al
;  PC = (a16)
;
ALIGNC
ALL_JMP_OaO:
 mov bl,[1+R_NativePC]
 mov bh,[2+R_NativePC]
 GET_BYTE
 inc ebx
 mov ah,al
 GET_BYTE
 xchg ah,al

 mov ebx,B_PB_Shifted
 mov R_NativePC,eax
 or eax,ebx

 shr eax,13
 mov eax,[_Read_Bank8Offset+eax*4]
 test eax,eax
 jnz .read_direct

 xor ebx,ebx
 mov eax,_Blank     ;we should really trap this...
.read_direct:
 add eax,ebx

 add R_NativePC,eax
 mov B_PBOffset,eax

 jmp near CPU_RETURN

; 6D
EM_ADC a,Absolute
E0_ADC a,Absolute

; 6E
EM_ROR a,Absolute
E0_ROR a,Absolute

; 6F
EM_ADC al,Absolute_Long
E0_ADC al,Absolute_Long
