; 65c816 opcodes 0xD0-0xDF:
;    D0: BNE r       2,2
;    D1: CMP (d),y   2,5
;    D2: CMP (d)     2,5
;    D3: CMP (d,s),y 2,7
;    D4: PEI s       2,6
;    D5: CMP d,x     2,4
;    D6: DEC d,x     2,6
;    D7: CMP [d],y   2,6
;    D8: CLD i       1,2
;    D9: CMP a,y     3,4
;    DA: PHX s       1,3
;    DB: STP i       1,3
;    DC: JML (a)     3,6
;    DD: CMP a,x     3,4
;    DE: DEC a,x     3,7
;    DF: CMP al,x    4,5

; D0
BFC BNE,SNES_FLAG_Z

; D1
EM_CMP OdO_y,Direct_Indirect_Indexed
E0_CMP OdO_y,Direct_Indirect_Indexed

; D2
EM_CMP OdO,Direct_Indirect
E0_CMP OdO,Direct_Indirect

; D3
EM_CMP Od_sO_y,Stack_Relative_Indirect_Indexed
E0_CMP Od_sO_y,Stack_Relative_Indirect_Indexed

; D4

ALIGNC
E0_PEI:
 READ16_Direct
 E0_PUSH_W
 jmp near CPU_RETURN

ALIGNC
E1_PEI:
 READ16_Direct
 E1_PUSH_W
 jmp near CPU_RETURN

; D5
EM_CMP d_x,Direct_Index_X
E0_CMP d_x,Direct_Index_X

; D6
EM_DEC d_x,Direct_Index_X
E0_DEC d_x,Direct_Index_X

; D7
EM_CMP IdI_y,Direct_Indirect_Indexed_Long
E0_CMP IdI_y,Direct_Indirect_Indexed_Long

; D8

ALIGNC
ALL_CLD:
 inc R_NativePC
 CLR_FLAG SNES_FLAG_D
 jmp near CPU_RETURN

; D9
EM_CMP a_y,Absolute_Index_Y
E0_CMP a_y,Absolute_Index_Y

; DA

ALIGNC
E0_PHX:
 inc R_NativePC
 mov eax,B_X
 E0_PUSH_W
 jmp near CPU_RETURN

ALIGNC
EX_PHX:
 inc R_NativePC
 mov eax,B_X
 E0_PUSH_B
 jmp near CPU_RETURN

ALIGNC
E1_PHX:
 inc R_NativePC
 mov eax,B_X
 E1_PUSH_B
 jmp near CPU_RETURN

; DC

; JML Absolute Indirect Long
;  PB:PC = [a16]
;
ALIGNC
ALL_JML_OaO:
 mov bl,[1+R_NativePC]
 mov bh,[2+R_NativePC]
 GET_BYTE
 inc ebx
 mov ah,al
 GET_BYTE
 xchg ah,al
 inc ebx
 mov R_NativePC,eax
 GET_BYTE
 mov B_PB,al
 test [MEMSEL],al   ; Check bus speed against PB
 mov bl,5
 jnz .fastrom
 mov bl,4
.fastrom:
 mov ah,0
 mov [CycleTable],bl    ; Update bus speed
 mov edi,R_NativePC
 shl eax,16
 or edi,eax

 shr edi,13
 mov edi,[_Read_Bank8Offset+edi*4]
 test edi,edi
 jnz .read_direct

 xor eax,eax
 mov edi,_Blank     ;we should really trap this...
.read_direct:
 add edi,eax

 add R_NativePC,edi
 mov B_PBOffset,edi

 jmp near CPU_RETURN

; DD
EM_CMP a_x,Absolute_Index_X
E0_CMP a_x,Absolute_Index_X

; DE
EM_DEC a_x,Absolute_Index_X
E0_DEC a_x,Absolute_Index_X

; DF
EM_CMP al_x,Absolute_Long_Index_X
E0_CMP al_x,Absolute_Long_Index_X
