/*

 This contains variable and function defintions used by both ASM and C++

 Many of these will be moved to other files as soon as I figure out where
  they belong...

*/

#include <stdio.h>
#include <unistd.h>

#include "wrapaleg.h"   /* Wrapper header for Allegro */

BEGIN_GFX_DRIVER_LIST
 GFX_DRIVER_VBEAF
 GFX_DRIVER_VGA
 GFX_DRIVER_MODEX
 GFX_DRIVER_VESA3
 GFX_DRIVER_VESA2L
 GFX_DRIVER_VESA2B
 GFX_DRIVER_XTENDED
 GFX_DRIVER_VESA1
END_GFX_DRIVER_LIST

BEGIN_COLOR_DEPTH_LIST
 COLOR_DEPTH_8
 COLOR_DEPTH_15
 COLOR_DEPTH_16
END_COLOR_DEPTH_LIST

#include "sound.h"

/* PPU.asm */
extern unsigned char Layering_Mode;
extern unsigned char Layer_Disable_Mask;
extern unsigned char Offset_Change_Disable;
extern void Update_Layering(void);
extern void Toggle_Offset_Change(void);

unsigned KEY_UP_1,KEY_DOWN_1,KEY_LEFT_1,KEY_RIGHT_1;
unsigned KEY_A_1,KEY_B_1,KEY_X_1,KEY_Y_1;
unsigned KEY_L_1,KEY_R_1,KEY_SELECT_1,KEY_START_1;
unsigned KEY_UP_2,KEY_DOWN_2,KEY_LEFT_2,KEY_RIGHT_2;
unsigned KEY_A_2,KEY_B_2,KEY_X_2,KEY_Y_2;
unsigned KEY_L_2,KEY_R_2,KEY_SELECT_2,KEY_START_2;

unsigned short ScreenX,ScreenY;
signed char MOUSE_PLUGGED_IN;

/*

unsigned long SNESPatch[10];    // Used to Apply Patches!
unsigned long *SNESPatchPtr=&SNESPatch[0];
unsigned long NumPatches=0;


	movl _NumPatches,%ecx
	movl _SNESPatchPtr,%edx
	cmpl $0,%ecx
	je 0f
1:
	movl (%edx),%esi
	movl %esi,%eax
	andl $0x00FFFFFF,%esi
	shrl $24,%eax
	SET_BYTE
	decl %ecx
	jne 1b
0:

 SNESPatch[0]=0x3F7E0B9D;
 NumPatches=1;

*/

typedef struct {
 unsigned short blue  :5;
 unsigned short green :6;
 unsigned short red   :5;
} colorRGB565;

typedef struct {
 unsigned short red   :5;
 unsigned short green :5;
 unsigned short blue  :5;
 unsigned short fill  :1;
} colorBGR555;

RGB SNES_Palette[256];                  /* So I can access from cc modules! */
colorBGR555 Real_SNES_Palette[256];     /* Updated by palette write */
colorRGB565 HICOLOUR_Palette[256][2];   /* values in here are plotted direct to PC! */
unsigned char BrightnessAdjust[16][256];/* Used for brightness effect */
unsigned char MosaicLine[16][256];      /* Used for mosaic effect */

/*
 This sets up BrightnessAdjust to be 16 tables each with 256 elements;
  table t, element e contains (t+1)e/16, except in table 0 where all
  elements are 0.
 This table is used for SNES brightness effects.

 This sets up MosaicLine to be 16 tables each with 256 elements;
  table t, element e contains (e-1)/(t+1)*(t+1)+1.
 This table is used for the mosaic effect.

 This function may eventually be expanded to set up other tables.
*/
void SetupTables(void)
{
 int t;
 for (t = 0; t < 256; t++) BrightnessAdjust[0][t] = 0;
 for (t = 1; t < 16; t++)
 {
  int e;
  for (e = 0; e < 256; e++)
  {
   BrightnessAdjust[t][e] = (t + 1) * e / 16;
   MosaicLine[t][e] = (e - 1) / (t + 1) * (t + 1) + 1;
  }
 }
}

void Reset_CGRAM(void)
{
 int i;
 for (i = 0; i < 256; i++)
 {
  Real_SNES_Palette[i].red = 0;
  Real_SNES_Palette[i].green = 0;
  Real_SNES_Palette[i].blue = 0;
 }
}

#ifdef DEBUG
unsigned Frames;
#endif

/* Mode 0 = 320x200x256 VGA     : Mode 1 = 320x200x256 VGA  FIT */
/* Mode 2 = 320x240x256 MODE-X  : Mode 3 = 256x256x256 MODE-X   */
/* Mode 4 = 320x200x16b SVGA    : Mode 5 = 320x240x16b SVGA     */
/* Mode 6 = 640x480x16b SVGA    : Mode 7 = 640x480x16b SVGA FIT */
unsigned char PC_SCREEN_MODE=0;

unsigned char *SNES_Screen;
unsigned char *SNES_Screen8;

BITMAP *Allegro_Bitmap=0;   /* Renamed (I'm using mostly allegro now so what the hell!) */
BITMAP *Internal_Bitmap=0;
BITMAP *Internal_Bitmap_blitsrc=0;

unsigned FRAME_SKIP_MIN;    /* Min frames waited until refresh */
unsigned FRAME_SKIP_MAX;    /* Max frames waited until refresh */
unsigned char SNES_COUNTRY; /* Used for PAL/NTSC protection checks */
unsigned char JOYSTICK_ENABLED=0;
unsigned char JOYSTICK_ENABLED2=0;
unsigned char SPC_ENABLED=0;

void OutputScreen()
{
 static int ScreenCount = 0;    /* Used to determine screen filename */
 char filename[13];

 while (ScreenCount <= 999)
 {
  sprintf(filename, "PICCY%03u.PCX", ScreenCount++);
  if (access(filename, F_OK)) break;
 }
 if (ScreenCount > 999){ ScreenCount = 0; return; }

 if (PC_SCREEN_MODE > 3)
 {
  save_pcx(filename, Allegro_Bitmap, SNES_Palette);
 } else {
  save_pcx(filename, Internal_Bitmap_blitsrc, SNES_Palette);
 }
}

char key_released[KEY_MAX];

static void key_release_callback(int scancode)
{
 key_released[scancode & ~0x80] |= (scancode & 0x80);
}
END_OF_STATIC_FUNCTION(key_release_callback);

void install_key_release_callback()
{
 int i;
 static int key_release_callback_installed = (0 != 0);

 if (key_release_callback_installed) return;

 LOCK_FUNCTION(key_release_callback);
 LOCK_VARIABLE(key_released);

 for (i = 0; i < KEY_MAX; i++) key_released[i] = -1;

 keyboard_lowlevel_callback = key_release_callback;
 key_release_callback_installed = (0 == 0);
}

int UPDATE_KEYS(void)
{
 if (key[KEY_F1] && key_released[KEY_F1] != 0)
 {
  key_released[KEY_F1] = 0; SPC_MASK ^= 1;
 }

 if (key[KEY_F2] && key_released[KEY_F2] != 0)
 {
  key_released[KEY_F2] = 0; SPC_MASK ^= 2;
 }

 if (key[KEY_F3] && key_released[KEY_F3] != 0)
 {
  key_released[KEY_F3] = 0; SPC_MASK ^= 4;
 }

 if (key[KEY_F4] && key_released[KEY_F4] != 0)
 {
  key_released[KEY_F4] = 0; SPC_MASK ^= 8;
 }

 if (key[KEY_F5] && key_released[KEY_F5] != 0)
 {
  key_released[KEY_F5] = 0; SPC_MASK ^= 0x10;
 }

 if (key[KEY_F6] && key_released[KEY_F6] != 0)
 {
  key_released[KEY_F6] = 0; SPC_MASK ^= 0x20;
 }

 if (key[KEY_F7] && key_released[KEY_F7] != 0)
 {
  key_released[KEY_F7] = 0; SPC_MASK ^= 0x40;
 }

 if (key[KEY_F8] && key_released[KEY_F8] != 0)
 {
  key_released[KEY_F8] = 0; SPC_MASK ^= 0x80;
 }

 if (key[KEY_1] && key_released[KEY_1] != 0)
 {
  key_released[KEY_1] = 0; Layer_Disable_Mask ^= 1;
 }

 if (key[KEY_2] && key_released[KEY_2] != 0)
 {
  key_released[KEY_2] = 0; Layer_Disable_Mask ^= 2;
 }

 if (key[KEY_3] && key_released[KEY_3] != 0)
 {
  key_released[KEY_3] = 0; Layer_Disable_Mask ^= 4;
 }

 if (key[KEY_4] && key_released[KEY_4] != 0)
 {
  key_released[KEY_4] = 0; Layer_Disable_Mask ^= 8;
 }

 if (key[KEY_5] && key_released[KEY_5] != 0)
 {
  key_released[KEY_5] = 0; Layer_Disable_Mask ^= 0x10;
 }

 if (key[KEY_7] && key_released[KEY_7] != 0)
 {
  key_released[KEY_7] = 0; Toggle_Offset_Change();
 }

 if (key[KEY_6] && key_released[KEY_6] != 0)
 {
  key_released[KEY_6] = 0;
  Offset_Change_Disable = 0;
  Layering_Mode = 0;
  Layer_Disable_Mask = 0xFF;
  SPC_MASK = 0xFF;
 }

 if (key[KEY_8] && key_released[KEY_8] != 0)
 {
  key_released[KEY_8] = 0;
  if (Layering_Mode++ >= 2) Layering_Mode = 0;
 }

 Update_Layering();

 if (key[KEY_0] && key_released[KEY_0] != 0)
 {
  key_released[KEY_0] = 0;
  OutputScreen();
 }

 if (key[KEY_ESC] && key_released[KEY_ESC] != 0)
 {
  key_released[KEY_ESC] = 0;
  return (0 == 0);
 }

 return (0 != 0);
}

unsigned short MickeyRead;  /* MSB = Yyyyyyyy  LSB = Xxxxxxxx */
unsigned char MouseButts;

void MickeyMouse()
{
 int mx,my;

 get_mouse_mickeys(&mx, &my);

 MouseButts=mouse_b << 6;   /* save button state at time of read */

 MickeyRead = 0;
 if (mx < 0)
 {
  MickeyRead |= 0x80;
  mx = -mx;
 }
 MickeyRead |= (mx >> 1) & 0x7F;
 if (my < 0)
 {
  MickeyRead |= 0x8000;
  my = -my;
 }
 MickeyRead |= ((my >> 1) & 0x7F) << 8;
}

unsigned char BrightnessLevel;  /* SNES Brightness level, set up in PPU.asm */

char fixedpalettecheck=0;

/* v0.15, we do palette conversion here */
/* v0.20, support for brightness effects in 16-bit modes */
void SetPalette()
{
 /* NB - CGRamAddress[256*2] contains 256 palette entries as follows:
         CGRamAddress[0*2+0] contains GGGRRRRR  R = Red component
         CGRamAddress[0*2+1] contains 0BBBBBGG  G = Green component
                                                B = Blue component

    So each 2 addresses contains 1 palette entry.
 */
 
 colorBGR555 color;
 colorRGB565 Hi;
 unsigned char Red,Green,Blue;
 int Count;

 if (PC_SCREEN_MODE > 3)    /* Hi colour mode so do different palette set up */
 {
  for (Count = 0; Count < 256; Count++)
  {
   color=Real_SNES_Palette[Count];

   Red = BrightnessAdjust[BrightnessLevel][color.red << 3];
   Green = BrightnessAdjust[BrightnessLevel][color.green << 3];
   Blue = BrightnessAdjust[BrightnessLevel][color.blue << 3];

   Hi.red = Red >> 3;
   Hi.green = Green >> 2;
   Hi.blue = Blue >> 3;
   HICOLOUR_Palette[Count][0] = Hi;
   HICOLOUR_Palette[Count][1] = Hi;

   /* We still have to do this or screenshot will fail */
   SNES_Palette[Count].r = Red >> 2;
   SNES_Palette[Count].g = Green >> 2;
   SNES_Palette[Count].b = Blue >> 2;
  }
 } else {
  for(Count = 0; Count < 256; Count++)
  {
   color = Real_SNES_Palette[Count];

   Red = BrightnessAdjust[BrightnessLevel][color.red << 3];
   Green = BrightnessAdjust[BrightnessLevel][color.green << 3];
   Blue = BrightnessAdjust[BrightnessLevel][color.blue << 3];

   SNES_Palette[Count].r = Red >> 2;
   SNES_Palette[Count].g = Green >> 2;
   SNES_Palette[Count].b = Blue >> 2;

  }
  set_palette_range((RGB *)SNES_Palette, 0, 255, FALSE);
 }
}

void CopySNESScreen()
{
 int oy, iy;

 switch (PC_SCREEN_MODE)
 {
  case 0:
  case 3:   /* VGA linear */
  case 2:   /* VGA mode-x */
   blit(Internal_Bitmap_blitsrc, screen, 0, 0,
    (ScreenX - 256) / 2, (ScreenY - 239) / 2,
    ScreenX < 256 ? ScreenX : 256,
    ScreenY < 239 ? ScreenY : 239);
   break;
  case 1:   /* VGA linear with squash */
   for (oy = 0; oy < (239 - 200); oy++)
   {
    for (iy = 0; iy < (200 / (239 - 200)); iy++)
    {
     blit(Internal_Bitmap_blitsrc, screen,
      ScreenX < 256 ? (256 - ScreenX) / 2 : 0,
      oy * (200 / (239 - 200) + 1) + iy,
      ScreenX < 256 ? 0 : (ScreenX - 256) / 2,
      oy * (200 / (239 - 200)) + iy,
      ScreenX < 256 ? ScreenX : 256,
      1);
    }
   }
   break;
  default:
   blit(Allegro_Bitmap, screen, 0, 0, 0, 0, ScreenX, ScreenY);
 }
}
