; SPC700 opcodes 0x90-0x9F:
;    90: BCC rel         2,2/4
;    91: TCALL 9         1,8
;    92: CLR1 dp.4       2,4
;    93: BBC dp.4,rel    3,5/7
;    94: ADC A,dp+X      2,4
;    95: ADC A,labs+X    3,5
;    96: ADC A,labs+Y    3,5
;    97: ADC A,(dp)+Y    2,6
;    98: ADC dp,#imm     3,5
;    99: ADC (X),(Y)     1,5
;    9A: SUBW YA,dp      2,5
;    9B: DEC dp+X        2,5
;    9C: DEC A           1,2
;    9D: MOV X,SP        1,2
;    9E: DIV YA,X        1,12
;    9F: XCN A           1,5
;

; 90
SPC_BFC BCC,SPC_FLAG_C
; 91
TCALL 9
; 92 - SPC_CLR1 in SPCmain.S
; 93 - SPC_BBC in SPCmain.S
; 94
SPC_ADC_A Odp_XO
; 95
SPC_ADC_A Oabs_XO
; 96
SPC_ADC_A Oabs_YO
; 97
SPC_ADC_A OOdpO_YO
; 98
SPC_ADC_mem dp_IM
; 99
SPC_ADC_mem OXO_OYO
; 9A

ALIGNC
SPC_SUBW_YA_dp:
 ADDR_dp
 CLR_FLAG_SPC SPC_FLAG_V    ; Done cos STORE_FLAGS cant alter V!
 GET_WORD_SPC        ; get DP word
 mov ebx,B_YA
 sub bx,ax
 cmc
 lahf
 jno .no_overflow
 SET_FLAG_SPC SPC_FLAG_V
.no_overflow:
 STORE_FLAGS_SPC_FROM SPC_FLAG_NHZC,ah
 mov B_YA,ebx
 jmp SPC_BACK

; 9B
SPC_DEC Odp_XO
; 9C
SPC_DEC_reg A
; 9D
SPC_MOV_reg_reg X,SP
; 9E

ALIGNC
SPC_DIV:                ; This may not be 100% due to overflow checking!
 inc R_NativePC
 xor ebx,ebx
 mov bl,B_X
 test bl,bl         ; If zero skip divide!
 jz SPC_DIV_OVERFLOW
 mov eax,B_YA       ; Dividend
 xor edx,edx
 div bx             ; Result is ax=quotient,dx=remainder
 test ah,ah         ; Check for overflow
 jnz SPC_DIV_OVERFLOW   ; (0.33) Butcha - fixed stack corruption
SPC_DIV_NO_OVERFLOW:
 mov [_A],al        ; Quotient in A
 mov [_Y],dl        ; Remainder in Y
 CLR_FLAG_SPC SPC_FLAG_V
 test al,al
 LOAD_BASE
 STORE_FLAGS_SPC SPC_FLAG_NZ
 jmp SPC_BACK
ALIGNC
SPC_DIV_OVERFLOW:
 SET_FLAG_SPC (SPC_FLAG_N+SPC_FLAG_V)
 CLR_FLAG_SPC SPC_FLAG_Z
 mov dword [_YA],0xFFFF
 LOAD_BASE
 jmp SPC_BACK

; 9F */

ALIGNC
SPC_XCN:
 mov al,B_A
 rol al,4
 inc R_NativePC
 test al,al
 mov B_A,al
 STORE_FLAGS_SPC SPC_FLAG_NZ
 jmp SPC_BACK
